def load_predictions(filename):
	f = open(filename)
	f.readline()
	preds = {}
	for row in f:
		data = row.strip().split(',')
		if data[0] not in preds:
			preds[data[0]] = []
		preds[data[0]].append(int(data[2]))

	f.close()
	return preds

def load_labels(filename):
	f = open(filename)
	f.readline()
	labels = {}
	for row in f:
		data = row.strip().split(',')		
		labels[data[0]] = int(data[1])
	f.close()
	return labels

def majority(preds):
	counts = {}
	for pred in preds:
		if pred in counts:
			counts[pred] += 1
		else:
			counts[pred] = 1
	maj_count = 0
	maj_pred = -1
	for pred,count in counts.items():
		if count > maj_count or count == maj_count  and pred > maj_pred:
			maj_count = count
			maj_pred = pred
	return maj_pred

def majority_accuracy(labels, frame_preds):
	correct = 0
	total = 0
	for patient, label in labels.items():
		if patient not in frame_preds:
			print("ERROR: prediction not found for patient %s, skipping.." %patient)
			continue
		maj_pred = majority(frame_preds[patient])
		if label == maj_pred:
			correct+=1
		total+=1
	return correct / total

predfile = input("Inserire nome file predizioni: ") 
labelfile = input("Inserire nome file annotazioni: ") 
frame_preds = load_predictions(predfile)
labels = load_labels(labelfile)
print("Majority accuracy = %f" %majority_accuracy(labels, frame_preds))
