from numpy import mean

def load_predictions(filename):
	f = open(filename)
	f.readline()
	preds = {}
	for row in f:
		data = row.strip().split(',')
		if data[0] not in preds:
			preds[data[0]] = []
		preds[data[0]].append(int(data[2]))

	f.close()
	return preds

def prediction_margin(predlist):
	counts = {}
	for pred in predlist:
		if pred in counts:
			counts[pred] += 1
		else:
			counts[pred] = 1
	countlist = list(counts.values())
	countlist.sort()
	if len(countlist) > 1:
		return countlist[-1]-countlist[-2]
	else:
		return countlist[0]

def predmargin_stats(preds):
	convex_margins = []
	linear_margins = []
	for name,predlist in preds.items():
		if name.startswith("convex"):
			convex_margins.append(prediction_margin(predlist))
		elif name.startswith("linear"):
			linear_margins.append(prediction_margin(predlist))
		else:
			print("Skipping unknown scan type " + name)
	return convex_margins,linear_margins

def print_stats(convex_margins,linear_margins):
	print("Convex scan prediction margin: %.2f" %mean(convex_margins))
	print("Linear scan prediction margin: %.2f" %mean(linear_margins))


predfile = input("Inserire nome file predizioni: ") 
preds = load_predictions(predfile)
convex_margins,linear_margins = predmargin_stats(preds)
print_stats(convex_margins, linear_margins)
