

def load_data(filename):
	f = open(filename)
	data = {}	
	max_label = 0
	f.readline()
	for row in f:
		rowdata = row.strip().split(',')
		scantype = rowdata[2].split('_')[0]
		label = int(rowdata[4])
		pred = int(rowdata[6])
		if scantype in data:
			data[scantype].append((label,pred))
		else:
			data[scantype] = [(label,pred)]
		if label > max_label:
			max_label = label
	f.close()
	return data, max_label


def confusion_matrix_by_scantype(data, max_label):

	for scantype,labelpreds in data.items():
		print(scantype)
		confusion_matrix(labelpreds, max_label)

def confusion_matrix(data, max_label):

	matrix = [[0 for row in range(max_label+1)] for row in range(max_label+1)]

	for (lab,pred) in data:
		matrix[lab][pred] += 1

	print("\t" + "\t".join([str(pred) for pred in range(max_label+1)]))
	for lab in range(max_label+1):
		predrow = str(lab)
		for pred in range(max_label+1):	
			predrow += "\t" + str(matrix[lab][pred])
		print(predrow)

filename = input("Inserire nome file: ")
data, max_label = load_data(filename)
confusion_matrix_by_scantype(data, max_label)


