
def load_data(filename):
	f = open(filename)
	data = {}
	locations = set()
	for row in f:
		[source, loc] = row.strip().split("_")[1].split(":")
		if not source in data:
			data[source] = {}
		if not loc in data[source]:
			data[source][loc] = [f.readline().strip()]
		else:
			data[source][loc].append(f.readline().strip())
		locations.add(loc)
	f.close()
	return data, locations

def sort_sources(data):
	sources = []
	for source, values in data.items():
		num = 0
		for loc, seqs in values.items():
			num += len(seqs)
		sources.append((num, source))
	sources.sort()
	return [source for num, source in sources]


def loc_stats(data, locations, sources):
	print("source\t" + "\t".join([loc for loc in locations]))
	for source in sources:
		values = data[source]
		print(source + "\t" + "\t".join(["%d" %len(values.get(loc, [])) for loc in locations]))


filename = input("Inserire nome file: ")
data, locations = load_data(filename)
sources = sort_sources(data)
loc_stats(data, locations, sources)
